program mask_slopes
implicit none
real dx, dy, dz, datum,counter,mav, dem_min, dem_max
integer*4 nx, ny, nz,mi,mj,ii,jj,dummy
integer lj,hj,li,hi,sflag,wsize,i,j,k,itcount,maxiter
real, allocatable :: grid(:,:,:),sx(:,:),sy(:,:),dem(:,:),dir(:,:),corr(:,:)
character*40 filename, dem_filename
character*2, allocatable :: string(:,:)

!set up dimensions for grid
nx = 90
ny = 80
nz = 10
dx = 100.
dy = 100.
dz = 0.1
dummy=1
wsize = 1
maxiter=750
dem_min = 10000000.
dem_max = -1000.

allocate (grid(nx,ny,nz),sx(nx,ny),sy(nx,ny),dem(nx,ny),dir(nx,ny),string(nx,ny),corr(nx,ny))

open(666,file='res_sl.txt')
open(667,file='topo_surface.txt')
open(668,file='x_slope.txt')
open(669,file='y_slope.txt')
! read in dem

dem_filename = 'pcr.txt'

open(10, file = trim(dem_filename))
!read(10,*)

do i = 1, nx
	read(10,*) (dem(i,j), j=1,ny)
end do

open(11, file = 'corr.pcr.txt')
!write(11,*)nx,ny,dummy

open(12, file = 'corr.dem.txt')
write(12,*)"X      Y       ALT"

!do j = 1, ny
!do i =1, nx
!read(10,*) dem(i,j)
!end do
!end do
close(10)

datum = 250.
grid = 0.

! loop over PF grid and set topo for CLM
! grid= 1 if w/in 10 nodes of Land Surface
! grid= 0 otherwise
!

sflag = 0
itcount = 0

do while (sflag == 0)
sflag=1
itcount = itcount + 1
print *,"ITERATION",itcount
! loop over and calculate slopes
sx = 0.
sy = 0.

do i = 1, nx
    do j = 1, ny
    if (i==1) then
      sx(i,j) = (dem(i+1,j)-dem(i,j))/(dx)
    elseif(i==nx) then
      sx(i,j) = (dem(i,j)-dem(i-1,j))/(dx)
    else
      if(dem(i+1,j) > dem(i,j) .and. dem(i-1,j) > dem(i,j)) then
        sx(i,j) = 0.0d0
      else  
        sx(i,j) = (dem(i+1,j)-dem(i-1,j))/(2.*dx)
      endif
    endif
    end do !j
end do  ! i

do i = 1, nx
    do j = 1, ny
    if (j==1) then
      sy(i,j) = (dem(i,j+1)-dem(i,j))/(dy)
    elseif(j==ny) then
      sy(i,j) = (dem(i,j)-dem(i,j-1))/(dy)
    else
      if(dem(i,j+1) > dem(i,j) .and. dem(i,j-1) > dem(i,j)) then
        sy(i,j) = 0.0d0
      else  
        sy(i,j) = (dem(i,j+1)-dem(i,j-1))/(2.*dy)
      endif
    endif
    end do !j
end do  ! i

!Compute flow direction
!do i=1,nx
!  do j=1,ny
!   dir(i,j)=sqrt((sx(i,j))*2.0d0+(sy(i,j)))*2.0d0
!   if(sx(i,j) < 0.0 .and. sy(i,j) < 0.0) string(i,j)="nw"
!   if(sx(i,j) > 0.0 .and. sy(i,j) > 0.0) string(i,j)="se"
!   if(sx(i,j) < 0.0 .and. sy(i,j) > 0.0) string(i,j)="sw"
!   if(sx(i,j) > 0.0 .and. sy(i,j) < 0.0) string(i,j)="ne"
!   if(sx(i,j) < 0.0 .and. sy(i,j) == 0.0) string(i,j)="ww"
!   if(sx(i,j) > 0.0 .and. sy(i,j) == 0.0) string(i,j)="ee"
!   if(sx(i,j) == 0.0 .and. sy(i,j) > 0.0) string(i,j)="ss"
!   if(sx(i,j) == 0.0 .and. sy(i,j) < 0.0) string(i,j)="nn"
!   if(sx(i,j) == 0.0 .and. sy(i,j) == 0.0) string(i,j)="oo"
!   enddo
!enddo

do i=1,nx
  do j=1,ny
   dir(i,j)=sqrt((sx(i,j))**2.0d0+(sy(i,j))**2.0d0)
   if(sx(i,j) < 0.0 .and. sy(i,j) < 0.0) string(i,j)="|-"
   if(sx(i,j) > 0.0 .and. sy(i,j) > 0.0) string(i,j)="-|"
   if(sx(i,j) < 0.0 .and. sy(i,j) > 0.0) string(i,j)="|-"
   if(sx(i,j) > 0.0 .and. sy(i,j) < 0.0) string(i,j)="-|"
   if(sx(i,j) < 0.0 .and. sy(i,j) == 0.0) string(i,j)="--"
   if(sx(i,j) > 0.0 .and. sy(i,j) == 0.0) string(i,j)="--"
   if(sx(i,j) == 0.0 .and. sy(i,j) > 0.0) string(i,j)="||"
   if(sx(i,j) == 0.0 .and. sy(i,j) < 0.0) string(i,j)="||"
   if(sx(i,j) == 0.0 .and. sy(i,j) == 0.0) string(i,j)="oo"
   enddo
enddo

!If there is a sink calc moving average
do i=1,nx
 do j=1,ny
   if (dir(i,j) == 0.0d0) then
   mav = 0.0
   counter = 0.0
   
   li = i - wsize
   hi = i + wsize
   lj = j - wsize
   hj = j + wsize
   if (j <= wsize) then
    lj = 1
   elseif (hj > (ny-wsize)) then
    hj = ny
   endif
   if (li <= wsize) then
    li = 1
   elseif (hi > (nx-wsize)) then
    hi = nx
   endif
    
!   do ii=li,hi
!     do jj=lj,hj
!       if (ii/=i.or.jj/=j) then
!       mav = mav + dem(ii,jj)
       counter = counter + 1.0
!       endif
!     enddo
!   enddo
!   mav = mav +0.15
!   mav = mav / (counter)
   dem(i,j) = dem(i,j) + 0.15
   endif
  enddo
 enddo
 
 ! Check if all sinks are filled
 do i = 1, nx
    do j = 1, ny
    if (i==1) then
      sx(i,j) = (dem(i+1,j)-dem(i,j))/(dx)
    elseif(i==nx) then
      sx(i,j) = (dem(i,j)-dem(i-1,j))/(dx)
    else
      if(dem(i+1,j) > dem(i,j) .and. dem(i-1,j) > dem(i,j)) then
        sx(i,j) = 0.0d0
      else  
        sx(i,j) = (dem(i+1,j)-dem(i-1,j))/(2.*dx)
      endif
    endif
    end do !j
end do  ! i

do i = 1, nx
    do j = 1, ny
    if (j==1) then
      sy(i,j) = (dem(i,j+1)-dem(i,j))/(dy)
    elseif(j==ny) then
      sy(i,j) = (dem(i,j)-dem(i,j-1))/(dy)
    else
      if(dem(i,j+1) > dem(i,j) .and. dem(i,j-1) > dem(i,j)) then
        sy(i,j) = 0.0d0
      else  
        sy(i,j) = (dem(i,j+1)-dem(i,j-1))/(2.*dy)
      endif
    endif
    end do !j
end do  ! i

do i=1,nx
  do j=1,ny
   dir(i,j)=sqrt((sx(i,j))**2.0+(sy(i,j))**2.0)
   if (dir(i,j) == 0.0d0.and.itcount<=maxiter) then
     sflag = 0
     print *,"sink at:",i,j,dem(i,j),counter
	 print *, i-1,j, dem(i-1,j)
	 print *, i,j-1, dem(i,j-1)
	 print *, i,j+1, dem(i,j+1)
	 print *, i+1,j, dem(i+1,j)
   endif  
   enddo
enddo

enddo !Iteration loop
 
do j=ny,1,-1
 write(666,*)(dir(i,j),i=1,nx)
 write(667,'(1000(a2,x))')(string(i,j),i=1,nx)
enddo

write(667,*)  
do j=1,ny
 write(667,'(1000(f6.2,x))')(dem(i,j),i=1,nx)
 write(668,*) (sx(i,j),i=1,nx)
 write(669,*) (sy(i,j),i=1,nx)
enddo

!do j = 1, ny
!do i = 1, nx
! write(11,*) dem(i,j)
! if (dem(i,j) > dem_max) dem_max = dem(i,j)
! if (dem(i,j) < dem_min) dem_min = dem(i,j)
!end do
!end do

do i = 1, nx
       write(11,*) (dem(i,j), j=1,ny)
end do

do j = 1, ny
do i =1, nx
 write(12,'(3(f6.2,x))') dfloat(i),dfloat(j), dem(i,j)
end do
end do
 
 print* 
! print*, 'dem_min',dem_min
! print*, 'dem_max',dem_max
end program mask_slopes


