program slopes

! aditi bhaskar (aditi.bhaskar@umbc.edu) modified from make_slopes.f90 by reed maxwell
! last modified 15 august 2008
! this takes the text files written out by enforceslopes.m and writes them as pfb files. 
! i am using ifort for this code. 

real*8 dx, dy, dz, datum,counter,mav,x
integer*4 nx, ny, nz, icount,mi,mj,ii,jj
integer lj,hj,li,hi,sflag
real*8, allocatable :: grid(:,:,:),sx(:,:),sy(:,:),dem(:,:),dir(:,:),corr(:,:)
character*40 filenamex, filenamey, slopexfilename, slopeyfilename, dem_filename, input_filename, text1, text2
character*2, allocatable :: string(:,:)

nx = 90
ny = 80
nz = 339
dx = 100.
dy = 100.
dz = 1.
filenamex = 'xslopeenf_full.pfb'
filenamey = 'yslopeenf_full.pfb'

slopexfilename='xslopeenf.txt'
slopeyfilename='yslopeenf.txt'

allocate (grid(nx,ny,nz),sx(nx,ny),sy(nx,ny),dem(nx,ny),dir(nx,ny),string(nx,ny),corr(nx,ny))

open(10, file = trim(slopexfilename))												
do i = 1, nx
	read(10,*) (sx(i,j), j=1,ny)
end do
close(10)

open(10, file = trim(slopeyfilename))												
do i = 1, nx
	read(10,*) (sy(i,j), j=1,ny)
end do
close(10)
  
do i =1, nx
    do j = 1, ny
        grid(i,j,1:nz) = sx(i,j)   !x slopes
    end do
end do

! write out slopes
call pf_write(grid,filenamex,nx,ny,nz,dx,dy,dz)


! write slopes to text file for error checking/plotting etc
print *,"X-Slopes successful"

do i =1, nx
    do j = 1, ny
        grid(i,j,1:nz) = sy(i,j)   ! y slopes
    end do
end do

! write slopes to text file for error checking/plotting etc
call pf_write(grid,filenamey,nx,ny,nz,dx,dy,dz)


print *,"Y-Slopes successful"
end program slopes


subroutine pf_write(x,filename,ixlim,iylim,izlim,dx,dy,dz)
Real*8 x(ixlim,iylim,izlim),  ri, rj, rk1, rk2, headsum,    &
rsum, junk,                                           &   
ksum, kavg,f, dx, dy, dz, x1, y1, z1
Integer*4 i,j,k, i1, j1, k1, ixlim, iylim, izlim, &
ns, ix, iy, iz, rx, ry, rz
character*40 filename

!
!	Open File
!
filename = trim(filename)
open(15,file=filename,form='unformatted',&
access='stream',convert='BIG_ENDIAN')
!
! Calc domain bounds
!
	ix = 0
	iy = 0
	iz = 0


	ns = 1

	rx = 1
	ry = 1
	rz = 1

	x1 = dble(ixlim)*dx
	y1 = dble(iylim)*dy
	z1 = dble(izlim)*dz
!
!	Write header info
!

write(15) x1
write(15) y1
write(15) z1

write(15) ixlim
write(15) iylim
write(15) izlim

write(15) dx
write(15) dy
write(15) dz

write(15) ns

write(15) ix
write(15) iy
write(15) iz

write(15) ixlim
write(15) iylim
write(15) izlim

write(15) rx
write(15) ry
write(15) rz


do  k=1,izlim
do  j=1,iylim
do  i=1,ixlim
write(15) x(i,j,k)
end do
end do
end do

close(15)
return
end

